// Belousov-Zabotinsky Reaction //


#include <string.h>
#include <3ds.h>
#include <math.h>


#define WIDTH  400
#define HEIGHT 240
#define SCREEN 400*240


	#define width  200
	#define height 120

	float a [width][height][2];
	float b [width][height][2];
	float c [width][height][2];

	int p = 0, q = 1;
	int x,y,i,j,l;



int main() {


	// Initialize services

	srvInit();
	aptInit();
	hidInit(NULL);
	gfxInit();

	//gfxSet3D(true); // uncomment if using stereoscopic 3D

	

	for (y = 0; y < height; y++) {
		for (x = 0; x < width; x++) {
			a[x][y][p] = (rand()%10/10.0);
			b[x][y][p] = (rand()%10/10.0);
			c[x][y][p] = (rand()%10/10.0);
			}
		}


	// Main loop

		while (aptMainLoop()) {


			gspWaitForVBlank();

			hidScanInput();


			u32 kDown = hidKeysDown();

			if (kDown & KEY_START) break;


			u8* fb = gfxGetFramebuffer(GFX_TOP, GFX_LEFT, NULL, NULL);
			
			//memset(fb, 0, SCREEN * 3);


			for (y = 0; y < height; y++) {

				for (x = 0; x < width; x++) {
	
					float c_a = 0;
					float c_b = 0;
					float c_c = 0;
	  
     				for (i = x - 1; i <= x+1; i++) {

        				for (j = y - 1; j <= y+1; j++) {

          					c_a += a[(i+width)%width][(j+height)%height][p];
          					c_b += b[(i+width)%width][(j+height)%height][p];
          					c_c += c[(i+width)%width][(j+height)%height][p];
        				}
      				}
      
	  			c_a /= 9.0;
      				c_b /= 9.0;
      				c_c /= 9.0;

      				if (c_a + c_a * (c_b - c_c) <= 1) a[x][y][q] = c_a + c_a * (c_b - c_c);
      				if (c_b + c_b * (c_c - c_a) <= 1) b[x][y][q] = c_b + c_b * (c_c - c_a);
      				if (c_c + c_c * (c_a - c_b) <= 1) c[x][y][q] = c_c + c_c * (c_a - c_b);
	  
	  			l = 256*a[x][y][q];

				fb[3*((2*y)+(2*x)*240)]   = l;
				fb[3*((2*y)+(2*x)*240)+1] = l;
				fb[3*((2*y)+(2*x)*240)+2] = l;
	  
				}
			}

	
			if (p == 0) { p = 1; q = 0; } else { p = 0; q = 1; }



			gfxFlushBuffers();

			gfxSwapBuffers();


		}

	// Exit services

	gfxExit();
	hidExit();
	aptExit();
	srvExit();

	return 0;

}